/* inmune1.c   Funcion 1 Archivo principal*/
/* Nareli Cruz Cortes */
/*Correr con:  ./inmune1 ciclos poblacion Pmi sigmai Tcruza
  por ejemplo: ./inmune1 30 30 3 1 2
  donde: ciclos es el numero de generaciones del AG interno
  poblacion es el tamanno de la poblacion
  Pmi es el porcentaje de mutacion que puede ser 1, 2 o 3
  sigma es la cantidad de individuos que se usan en el AG interno, puede 
ser  1 o 2 (todos los individuos o solo la mitad)
  y Tcruza es el tipo de cruza, se usa: 1 (un punto), 2 (2puntos), 3 
(uniforme)
  El archivo E1.txt tiene los datos del problema, como rango de las
variables, cantidad de restricciones, etc.
*/

#include "cabeza.h"

/* Funcion de aptitud, los valores de las x's van en un arreglo con numeracion
secuencial*/
double Evalua (double x[])
{evaluaciones++;
return (
5*(x[0]+x[1]+x[2]+x[3]) - 
5*(pow(x[0],2)+pow(x[1],2)+pow(x[2],2)+pow(x[3],2)) -
(x[4]+x[5]+x[6]+x[7]+x[8]+x[9]+x[10]+x[11]+x[12]));
}


double Penaliza ( double x[] )
{double fac = 1;
  TantoViola=0.0;RestVioladas=0.0;
  restricciones++; 
   g[0] = ((2*x[0]) + (2*x[1])+x[9] + x[10] -10 );
 g[1] = ((2*x[0]) + (2*x[2])+x[9] + x[11] -10 );
 g[2] = ((2*x[1]) + (2*x[2])+x[10] + x[11] -10 );
 g[3] = ((-8*x[0]) + x[9] );
 g[4] = ((-8*x[1]) + x[10] );
 g[5] =  ((-8*x[2]) + x[11] );
 g[6] =  ((- 2*x[3]) - x[4] + x[9]);
 g[7] =  ((- 2*x[5]) - x[6] + x[10]);
 g[8] =  ((- 2*x[7]) - x[8] + x[11]);
  
 if (g[0] > 0 ) {RestVioladas++;TantoViola=TantoViola+g[0];fac=0;}
 if (g[1] > 0 ) {RestVioladas++;TantoViola=TantoViola+g[1];fac=0;}
 if (g[2] > 0 ) {RestVioladas++;TantoViola=TantoViola+g[2];fac=0;}
 if (g[3] > 0 ) {RestVioladas++;TantoViola=TantoViola+g[3];fac=0;}
 if (g[4] > 0 ) {RestVioladas++;TantoViola=TantoViola+g[4];fac=0;}
 if (g[5] > 0 ) {RestVioladas++;TantoViola=TantoViola+g[5];fac=0;}
 if (g[6] > 0 ) {RestVioladas++;TantoViola=TantoViola+g[6];fac=0;}
 if (g[7] > 0 ) {RestVioladas++;TantoViola=TantoViola+g[7];fac=0;}
 if (g[8] > 0 ) {RestVioladas++;TantoViola=TantoViola+g[8];fac=0;}
 return fac;
}


/*vacia al arreglo Hijos aquellos que fueron seleccionados*/
void asigna1()
{ int i, j, indice;
 for (i=0; i<TamAux; i++) {
   indice = floor(ValEsp[i][1]);
   for (j=0; j<longitud; j++) 
     Hijos[i][j] = cromo[indice][j];
 }
}


/* Funcin Principal */
int main(int argc, char *argv[])
{ int i, gen = 0, c, j, QFac,mejor;
 
 printf("\nSistema Inmune Artificial\n");
 global=fopen("s1.txt","a");
 input1=fopen("E1.txt","r");
 Ciclos=atoi(argv[1]);
 TamAux=atoi(argv[2]);
 Pmi=atoi(argv[3]);
 sigmai=atoi(argv[4]);
 Tcruza=atoi(argv[5]);
 
 lee(input1);
 aleatorio();
 Inicializa();  /*genera la poblacin inicial*/
 Pc=0.8;
 suma=0;
 totalevaluaciones=350000;
 Gmax = totalevaluaciones/TamAux;   //generaciones aproximadas
 if(Pmi==1)
   Pm=(1/(double)longitud)*2; 

 if((Pmi==2)||(Pmi==3)){
   Pm=0.4;    //un valor alto inicial
   incremento=(Pm-(1/(float)longitud))/(float)Gmax;  //deberia ser decremento
   //   printf(" Pm.inicial=%f",Pm);
 }
 
 /**********************************/
 // ciclo principal del gentico
 while (evaluaciones < totalevaluaciones) {
   factibles=0;
   for (i=0; i<TamAux; i++){
     CodificaDecodifica (i);
     penas(i);
   }
   QFac = Inmune(gen);
   factibles=0;
   for (i=0; i<TamAux; i++){
     CodificaDecodifica(i);
   }
   Calculos();    //aqui deberia ser todo
   torneoE();  //no necesita ValEsp
   asigna1();   //asigna los seleccionados a Hijos
   cruza(Hijos, TamAux);    //de hijos
   Mutacion(Hijos,TamAux,Pm);   //de Hijos
   mejor=Elitismo(gen);//de cromo y lo pone en Hijos
   NextG();      //pone Hijos en cromo
   gen++;
   if(Pmi!=1)   //es decir 2 o 3
     if(Pm>=(1/(double)longitud))
       Pm=Pm-incremento;
   //printf("%f ",Pm);
 }
 /***** termina el ciclo principal *****/
 for (i=0; i<TamAux; i++)
   CodificaDecodifica (i);
 Calculos();    //aqui deberia ser todo
 mejor=Mayor();
 fprintf(global,"\n%f ",datos[mejor][0]);
 
 printf("\n%f\n",datos[mejor][0]);   //aptitud
 for(i=0; i<NumVar; i++)
   printf(" %f",variables[mejor][i]);
 
 if(datos[mejor][1]==0){    //factibilidad
   fprintf(global," factible= %.0f",datos[mejor][1]);
   printf(" factible= %.0f",datos[mejor][1]);
 }
 fcloseall();
 
 printf("\nFuncion 1 evaluaciones=%d, generaciones=%d\n",evaluaciones,gen);
 printf("\nGmax=%d",Gmax);
 return (0);
}
