/* interno.c */
int  IndiceFac=0, IndiceInf=0, marca,sigma, final;
unsigned Fac[TamFijo][LimiteDeCromosoma], Infac[TamFijo][LimiteDeCromosoma],
Hijos2[TamFijo][LimiteDeCromosoma];
double InfacDatos[TamFijo][2], Prom2;
unsigned compara[LimiteDeCromosoma];

int AptitudInterna (int);
void CalculosInterno (int);
int Mayor2(int);
int Inmune(int);
void SigGen(int);
void Elitismo2(int);

/*toma una muestra tamao sigma de infactibles a los que le calcula su aptitud respecto a un individuo factible*/
void CalculosInterno (int NumInfac)
{ int i = 0, j, seleccion, grandeI,k, T;
 for(i=0; i<NumInfac; i++)  //lo blanquea
   InfacDatos[i][0]=0;
 
 /*tamao de la muestra sigma, de ANTICUERPOS*/
 if (sigmai==1)
   sigma = NumInfac;  //todos los anticuerpos
 if (sigmai==2) {
   if (NumInfac>3)
     sigma = (int)NumInfac/2;  //la mitad de los anticuerpos
   else{
     sigma=2;
     if (NumInfac==1)sigma=1;
   }
 }
 for ( j=0; j<sigma; j++) {
   seleccion = rnd(0,NumInfac-1);
   T = AptitudInterna(seleccion);
   InfacDatos[seleccion][0]=(double)T;
   //   printf(" %d",T);
 }
}


//recibe el cromosoma a evaluar y contra quien lo va a evaluar
int AptitudInterna (int indica)
{int kontador=0;
 int  j, juntos=0, band=1;
 
 if (IndiceFac == 0) {    //no hay factibles, compara contra el mejor
   marca = indiceCl;
   for (j=0; j<longitud; j++)
     compara[j]=cromo[marca][j];
 }
 else {   //si hay factibles, antigenos
   marca = rnd(0,IndiceFac-1);
   for(j=0; j<longitud; j++) 
     compara[j]=Fac[marca][j];
 }
 //Modificacion: tener en cuenta cuando las igualdades son contiguas 
 for (j=0; j<longitud; j++){
   if (Infac[indica][j] == compara[j]){
     juntos++;
     band=1;
   }
   else
     band=0;
   if((!band) && (juntos>0)){
     kontador = kontador + pow(juntos,2);
     juntos=0;
     band=1;
   }
 }
 if(band && (juntos>0))
   kontador = kontador + pow(juntos,2);
 return kontador;
}


void Elitismo2 (int NumInfac)
{int c, r, esmayor;
 r = rnd (0, NumInfac-1);
 esmayor = Mayor2(NumInfac);
 for (c = 0; c < longitud; c++)
   Hijos2[r][c] = Infac[esmayor][c];
}


/*Calcula el mejor individuo de la poblacion en esa generacion*/
/*de los infactibles*/
int Mayor2 (int NumInfac)
{ int i, mas=0;
  for (i = 1; i < NumInfac; i++) {
    if ( InfacDatos[mas][0] < InfacDatos[i][0] )
      mas = i;
  }
  return mas;
}


void SigGen(int NumInfac)
{  int i, j;
 for (i=0; i<NumInfac; i++) 
   for ( j=0; j<longitud; j++)
     Infac[i][j] = Hijos2[i][j];
}


void asigna2(int NumInfac)
{ int i, j,k=0, indice,p=0;
 final=0;
 //los que se van a cruzar, quedan en Hijos2
 //quiero que la poblacion sea una mezcla de un ag-ab, ag-ab,...
 if (IndiceFac==0){    //no hay factibles
   for (i=0; i<NumInfac; i++) {
     indice = floor(ValEsp[i][1]);
     for (j=0; j<longitud; j++) 
       Hijos2[i][j] = Infac[indice][j];
   }
   final=NumInfac;
 }
 else{
   if(IndiceFac > NumInfac){   //hay muchos factibles
     for (i=0; i<NumInfac; i++) {  //hasta que se terminen los infactibles
       indice = floor(ValEsp[i][1]);  //pone un infactible
       for (j=0; j<longitud; j++) 
	 Hijos2[p][j] = Infac[indice][j];
       p++;
       for (j=0; j<longitud; j++)    //con un factible
	 Hijos2[p][j] = Fac[k][j];   //la k avanza sobre los factibles
       p++; k++;
     }  //del for
     final=p;
   }
   else{   //hay pocos factibles. Caso mas comun
     for (i=0; i<NumInfac; i++) {
       indice = floor(ValEsp[i][1]);  //pone un infactible
       for (j=0; j<longitud; j++) 
	 Hijos2[p][j] = Infac[indice][j];
       p++;
       if(k <= IndiceFac){
	 for (j=0; j<longitud; j++)    //con un factible
	   Hijos2[p][j] = Fac[k][j];
	 p++; k++;
       } 
     }  //del for
     final=p;
   }
 }
}


/*funcion del torneo binario para el algoritmo interno, gana el individuo con mejor aptitud, si estas son iguales, entonces se selecciona al ganador de manera aleatoria*/
void torneoI (int NumInfac)
{int uno, dos, i, sel;
 for (i = 0; i <NumInfac; i++){ /*toda la poblacin*/
   dos = rnd(0,NumInfac-1);
   uno = i;
   if (InfacDatos[uno][0] > InfacDatos[dos][0])
     sel = uno;
   else
     if (InfacDatos[uno][0] < InfacDatos[dos][0])
       sel = dos;
     else   /*son iguales*/
       if (flip(0.5))    /*entonces al azar*/
	 sel = uno;
       else
	 sel = dos;
   ValEsp[i][1] = sel;
 } /*recorrido de la poblacin*/
}


/*Esta es la funcin principal del algoritmo gentico interno*/
int Inmune (int generacion)
{ int i, j, ciclos, bandera=1,k=0,checa=0;
 double Pr=0;
 IndiceFac=0; IndiceInf=0;
 
 /*Divide a la poblacin en factibles e infactibles*/
 for (i=0; i<TamAux; i++) {
   if (datos[i][1] == 1) {// Si  es factible
     for (j=0; j<longitud; j++)
       Fac[IndiceFac][j] = cromo[i][j];  /*todo el cromosoma*/
     IndiceFac++;
   }
   else {     /*no es factible*/
     for (j=0; j<longitud; j++) {
       Infac[IndiceInf][j] = cromo[i][j];
     }
     IndiceInf++;
   }  /*del else*/
 }  /* del for*/

 /*HASTA AQUI O.K! dividio en factibles e infactibles*/
 /******************************/
 CalculosInterno(IndiceInf);
 
 /* inicia el ciclo principal*/
 for ( ciclos=0; ciclos<Ciclos; ciclos++) {
   torneoI(IndiceInf);
   asigna2(IndiceInf);   /*asigna los seleccionados a Hijos2*/
   cruza(Hijos2, final);
   if(Pmi!=3)  //1 o 2, Pm igual al externo
     Mutacion(Hijos2,final,Pm);
   if(Pmi==3)   //Pm interno es diferente
     Mutacion(Hijos2,final,(1/(double)longitud));
   
   Elitismo2(IndiceInf);
   SigGen(IndiceInf);
   /*en caso de no haber factibles, va checando si se gener alguno, para entonces usarlo para comparar contra l cada 5 vueltas*/
   if (IndiceFac==0){   /*no hay factibles*/
     if(ciclos%4==0){
       /*Checa si se gener algn individuo factible*/
       for (i=0; i<IndiceInf; i++) {
	 for ( j = 0; j < longitud; j++)
	   cromo[i][j] = Infac[i][j];   /*la lleva a cromo para*/
	 CodificaDecodifica(i);   /*saber si ya es factible*/
	 penas(i);
       }
       /*Revisa si ya existe algn factible para compara contra l*/
       for (i = 0; i < IndiceInf; i++){
	 if (datos[i][1] == 1){   /*Si es factible*/
	   for (j = 0; j < longitud; j++)/*lo registra como nuevo factible*/
	     Fac[IndiceFac][j] = cromo[i][j];   /*todo cromo*/
	   IndiceFac++;
	 }
       }
     }  //del if de cada n vueltas
   }  /*del if que no hay factibles*/
   CalculosInterno(IndiceInf);
 } /*sale del ciclo de gen*/
 
 /*poner todos los infactibles en cromo*/
 for (i=0; i<IndiceInf; i++)
   for (j=0; j<longitud; j++)
     cromo[i][j] = Infac[i][j];
 k=0;
 for ( i=IndiceInf; i<TamAux; i++){
   for ( j=0; j<longitud; j++)
     cromo[i][j] = Fac[k][j];
   k++;
 }
 // printf(" i=%d,T=%d ",IndiceInf,TamAux);
 return (IndiceFac);
}
