/* este es operador.c */
/*contiene las funciones de seleccin, cruza, mutacin, clculo de valor esperado, inicializacin y calculo, (para ambos algoritmos interno y externo)*/

unsigned Hijos[TamFijo][LimiteDeCromosoma];
double TantoViola,RestVioladas, promedio, PromViolacion;
int Mutas = 0, Cruzas = 0, mejor;

void Inicializa(void);
void NextG(void);
int Mayor(void);
int Elitismo(int);
void Cruza1pto (unsigned [][], int);
void Cruza2pto (unsigned [][], int);
void CruzaUniforme (unsigned [][], int );
void torneoE (void);

void penas(int i)
{ datos[i][1] = Penaliza(variables[i]);  /*factibilidad*/
  datos[i][2] = TantoViola;

  if(i==0)
    indiceCl = 0;
  else
    if(TantoViola < datos[indiceCl][2])
      indiceCl = i;
}


/*Busca el signo de puntuacin "dos puntos" (:) y con ello se marca el inicio de un dato que se deber leer*/
void lee (FILE *Darchivo)
{ char c; int i;
 char optimiza[20];

 Ceros=7;

  c=fgetc(Darchivo);
  while (c !=':') 
    c=fgetc(Darchivo);
  fscanf (Darchivo, "%d", &NumVar);

 c=fgetc(Darchivo);
  while (c !=':') 
    c=fgetc(Darchivo);
  fscanf (Darchivo, "%d", &Qg);

  c=fgetc(Darchivo);
  while (c !=':') 
    c=fgetc(Darchivo);
  c=fgetc(Darchivo);
  while (c !='\n') 
    c=fgetc(Darchivo);
  
  for (i=0; i<NumVar; i++){
    c=fgetc(Darchivo);
    while (c !='\n') 
      c=fgetc(Darchivo);
    fscanf (Darchivo, "%f", &LimInf[i]);    /*limite inferior cada variable*/
    c=fgetc(Darchivo);  /*fin de linea*/
    
    fscanf (Darchivo,"%f", &LimSup[i]);  /*limite superior de cada variable*/
    c=fgetc(Darchivo);   /*fin de linea*/
  }
  c=fgetc(Darchivo);
  while (c !=':') 
    c=fgetc(Darchivo);
  fgets(optimiza,4,Darchivo);          /*minimiza o maximiza*/
  if(strcmp(optimiza,"min")==0)
    MINMAX=0;
  else
    if(strcmp(optimiza,"max")==0)
      MINMAX=1;
    else{
      printf("\nError. Debes decir si minimiza 'min', o maximiza 'max'\n");
      exit(0);
    }

  Tseleccion=6;
  llena();
  fclose(Darchivo);
}


/*Dependiendo del tipo de cruza, se manda a ejecutar desde aqui*/
/* recibe como parmetros: el arreglo al que se le aplicar cruza y el tamao de  ese arreglo*/
void cruza (unsigned aqui[][longitud], int largo)
{
  if (Tcruza==1)
    Cruza1pto (aqui,largo);
  if (Tcruza==2)
    Cruza2pto (aqui,largo);
  if (Tcruza==3)
    CruzaUniforme (aqui,largo);
} 


/*dependiendo del tipo de seleccin leida, desde aqu se llaman a las funciones*/
/* el parmetro T es el tamao del arreglo, es decir el tamao de la poblacin*/

/* inicializa las cadenas de cromosomas en forma aleatoria */
void Inicializa()
{
 int i, c;
 for ( i = 0; i < TamAux; i++) {
   for ( c = 0; c < longitud; c++ ){
     cromo[i][c] = flip(0.5); /*Aleatoria */
     // printf(" %d",cromo[i][c]);
   }
 }
}


/* de Gray a binario, a real, limite*/
void CodificaDecodifica(int i)
{ int p,j;
  GrayBin(cromo[i], cromoBin); /*Convierte cadena Gray a Binar*/

  /* convierte las cadenas binarias a numeros reales*/
  for (p=0; p<NumVar; p++) 
    variables[i][p]=decode(tam[p], fin[p], LimInf[p]);

  /*verifica que los valores de las variables estn en elRango*/
  for (p=0; p<NumVar; p++)
    variables[i][p]=Limite(variables[i][p],tam[p],LimSup[p],LimInf[p]);
}


void Calculos ()
{ int i=0,infeasibles=0;
 double SumApt=0.0,SumViola=0.0;
 indiceCl=0;

 for (i = 0; i < TamAux; i++) {           /*cada individuo*/
   datos[i][1] = Penaliza(variables[i]);  //factibilidad
   datos[i][2] = TantoViola;          /*que tanto se viola*/
   SumViola = SumViola + TantoViola;
   datos[i][5] = -1 * TantoViola;
   datos[i][3] = RestVioladas; /*cuantas restricciones viola*/
   datos[i][0] = Evalua (variables[i]);   //aptitud
   datos[i][4] = datos[i][0];     //una copia de la aptitud
   if (!MINMAX)    //si se esta' minimizando
     datos[i][4] = -1 * datos[i][0];
   
   if (datos[i][1]==0) {     /*si no es factible 1*/
     if (infeasibles==0)   /*primer infactible encontrado*/
       indiceCl = i;
     else {  /*si no es el primer infactible que encuentra 2*/
       if (TantoViola < datos[indiceCl][2])/*para calidad menor*/
	 indiceCl=i;
       if(TantoViola == datos[indiceCl][2]) { /*viola igualCl 3*/
	 /*Buscar el mas apto*/
	 if (datos[i][4]>datos[indiceCl][4])
	   indiceCl=i;
	 if (datos[i][4]==datos[indiceCl][4]){ /*igual aptos 4*/
	   if(datos[i][3]<datos[indiceCl][3])/*menos restricc*/
	     indiceCl=i;
	   if(datos[i][3]==datos[indiceCl][3]) /*igual restric*/
	     if(flip(0.5)) /*azar*/
	       indiceCl=i;
	 } /*si son igual aptos 4*/
       } /* if viola igual Cl 3*/
     } /*else no es primer factible 2*/
     infeasibles++;
   } /*si no es factible 1*/
 } /*for que recorre la poblacion*/
}


/*Obtiene el indice del individuo de mayor aptitud de la poblacion */
/*El de mayor aptitud si hay factibles*/
/*si no hay factibles, es el indiceCl que indica */
int Mayor ()
{
  int i, mas=-1;
  for ( i=0; i<TamAux; i++)   /*busca el primer factible */
    if (datos[i][1] == 1) {
      mas = i;
      break;
    }
  if (mas != -1) {  /*si hay uno factible al menos*/
    for ( i = 0; i < TamAux; i++ )  /*busca mayor factible*/
      if ((datos[i][4]  > datos[mas][4]) && (datos[i][1]==1))
	mas = i;
  }
  if (mas == -1)  /*no hay individuos factibles*/
    mas= indiceCl;
  return (mas);
}


/* seleccin por torneo binario*/
/*Prefiere un factible sobre un infactible, uno que viole menos,despues prefiere mas apto,con menos restricciones violadas, finalmente al azar */
void torneoE ()
{int uno, dos, i, j, sel;

  for (i = 0; i <TamAux; i++) { /*toda la poblacin*/
    dos = rnd(0,TamAux-1);
    uno = i;
    if ((datos[uno][1]==1)&&(datos[dos][1]==1)){/*ambosFactibles*/
      if (datos[uno][4]<datos[dos][4])
	sel=dos;
      else
	sel=uno;
    }
    
    if ((datos[uno][1]==1)&&(datos[dos][1]==0)) /*fac sobre inf*/
      sel=uno;
    
    if ((datos[uno][1]==0)&&(datos[dos][1]==1)) /*fac sobre inf*/
      sel=dos;
    
    if ((datos[uno][1]==0)&&(datos[dos][1]==0)) {       /*ambos infact 1*/
      if (datos[uno][2] < datos[dos][2]) /*prefiere viola menos*/
	sel=uno;
      else
	if (datos[uno][2] > datos[dos][2]) /*viola menos*/
	  sel=dos;
	else {         /*violan iguales.Escoge mas apto 2*/
	  if (datos[uno][4]<datos[dos][4])
	    sel=dos;
	  if (datos[uno][4]>datos[dos][4])
	    sel=uno;
	  if (datos[uno][4]==datos[dos][4])   /*igual de aptos*/
	    if (datos[uno][3]<datos[dos][3])   /*por resriccionVio*/
	      sel=uno;
	    else
	      if (datos[uno][3] > datos[dos][3])
		sel=dos;
	      else /*iguales restricciones*/
		if (flip(0.5)) /*azar*/
		  sel=uno;
		else
		  sel=dos;
	} /*2*/
    }/*1*/
    ValEsp[i][1] = sel;
  } /*recorrido de la poblacin*/
}


/* Cruza de un punto, parmetros: arreglo sobre que se aplica y su tamao */
void Cruza1pto (unsigned aqui[][LimiteDeCromosoma], int lim)
{ int i, j, t=0, punto;
  unsigned T; Cruzas = 0;
  if ( (lim % 2) != 0)
    t = 1;

  for (i = t; i < lim; i+=2)
    if ( flip(Pc) ) {
      punto = rnd(1,longitud-2);
      for ( j = punto; j < longitud; j++) {
	T = aqui[i+1][j];
	aqui[i+1][j] = aqui[i][j];
	aqui[i][j] = T;
      }
      Cruzas++;
    }
}


/* Cruza de dos puntos */
void Cruza2pto (unsigned vector[][LimiteDeCromosoma], int lim)
{
  int i, j, t=0,punto1,punto2,temp;
  unsigned T;
  Cruzas = 0;
  if ( (lim % 2) != 0)
    t = 1;

  for (i = t; i < lim; i+=2)
    if ( flip(Pc) ) {   /*debe hacerse la cruza*/
      punto1 = rnd(1,longitud-2);
      punto2 = rnd(1,longitud-2);
      if (punto1 > punto2){ /*invertirlos*/
	temp = punto1;
	punto1 = punto2;
	punto2 = temp;
      }
      for ( j=punto1; j<punto2; j++){ /*cruza los centros*/
	T = vector[i+1][j];
	vector[i+1][j] = vector[i][j];
	vector[i][j] = T;
      }
      Cruzas++;
    }
}


void CruzaUniforme(unsigned vector[][LimiteDeCromosoma], int lim)
{
  int i, j, t=0;
  unsigned T;
  Cruzas = 0;
  if ( (lim % 2) != 0)
    t = 1;
  for (i = t; i < lim; i+=2)
    if ( flip(Pc) ) {  /* se debe realizar la cruza */
      for ( j = 0; j < longitud; j++) { 
	if (flip(0.5)) {   /*invertir los valores */
	  T = vector[i+1][j];
	  vector[i+1][j] = vector[i][j];
	  vector[i][j] = T;
	}
      }
      Cruzas++;
    }
}


/* Realiza el proceso de Mutacion */
void Mutacion (unsigned aqui[][longitud], int lim, double ppmm)
{int i = 0, c = 0, x, j;
  for (i = 0; i < lim; i++)
    for (c = 0; c < longitud; c++){
      if ( flip(ppmm) ){
	if ( aqui[i][c] == 1)
	  aqui[i][c] = 0;
	else
	  aqui[i][c] = 1;
	Mutas++;
      }
    }
}


/* Selecciona aleatoriamente cual individuo es el que se*/
/* reemplazar por el elitista y lo guarda en hijos. */
int Elitismo (int generacion)
{ int c, r = rnd (0,TamAux-1);
  int puntero;
  puntero = Mayor();
  for (c = 0; c < longitud; c++)
    Hijos[r][c] = cromo[puntero][c];
  return(puntero);
}
 

/*Realiza la actualizacion de valores para la nueva generacion*/
void NextG ()
{int i, c;

 for ( i = 0; i < TamAux; i++ )
   for ( c = 0; c < longitud; c++ )
     cromo[i][c] = Hijos[i][c];
}
